#!/usr/bin/env node
'use strict';

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _open = require('open');

var _open2 = _interopRequireDefault(_open);

var _yargs = require('yargs');

var _yargs2 = _interopRequireDefault(_yargs);

var _libServer = require('../lib/server');

var _path = require('path');

var _interpret = require('interpret');

var _interpret2 = _interopRequireDefault(_interpret);

var argv = _yargs2['default'].argv;
var cwd = process.cwd();

function registerCompiler(moduleDescriptor) {
	if (moduleDescriptor) {
		if (typeof moduleDescriptor === "string") {
			require(moduleDescriptor);
		} else if (!Array.isArray(moduleDescriptor)) {
			moduleDescriptor.register(require(moduleDescriptor.module));
		} else {
			for (var i = 0; i < moduleDescriptor.length; i++) {
				try {
					registerCompiler(moduleDescriptor[i]);
					break;
				} catch (e) {
					// do nothing
				}
			}
		}
	}
}

function load(entry) {
	var configPath, ext;
	var extensions = Object.keys(_interpret2['default'].extensions).sort(function (a, b) {
		return a.length - b.length;
	});
	configPath = (0, _path.resolve)(entry);
	for (var i = extensions.length - 1; i >= 0; i--) {
		var tmpExt = extensions[i];
		if (configPath.indexOf(tmpExt, configPath.length - tmpExt.length) > -1) {
			ext = tmpExt;
			break;
		}
	}
	if (!ext) {
		ext = path.extname(configPath);
	}
	registerCompiler(_interpret2['default'].extensions[ext]);
	return require(configPath);
}

var server = (0, _libServer.createServer)({
	client: load(argv.client),
	server: load(argv.server)
});

server.listen(process.env.PORT, function () {
	var url = 'http://localhost:' + server.address().port + '/';
	console.log('💎  Ready: ' + url + '.');
	if (!process.env.PORT) {
		(0, _open2['default'])(url);
	}
});
//# sourceMappingURL=webpack-udev-server.js.map