'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports['default'] = createAssetServer;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

var _webpackDevServer = require('webpack-dev-server');

var _webpackDevServer2 = _interopRequireDefault(_webpackDevServer);

var _webpack = require('webpack');

var _webpack2 = _interopRequireDefault(_webpack);

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var defaults = {
	hot: true,
	inline: true,
	historyApiFallback: false,
	publicPath: '/',
	headers: {
		'Access-Control-Allow-Origin': '*'
	}
};

function createAssetServer(assets, options) {
	var events = new _events2['default']();
	var compiler = (0, _webpack2['default'])(assets);
	var server = new _webpackDevServer2['default'](compiler, _extends({}, defaults, options));

	var emit = server.listeningApp.emit;
	server.listeningApp.emit = function () {
		for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
			args[_key] = arguments[_key];
		}

		emit.apply(server.listeningApp, args);
		events.emit.apply(events, args);
	};

	compiler.plugin('done', function (stats) {
		return events.emit('stats', stats);
	});

	return Object.assign(events, {
		compiler: compiler,
		listen: function listen() {
			server.listen.apply(server, arguments);
		},
		address: function address() {
			return server.listeningApp.address();
		},
		close: function close() {
			server.middleware.watching.close();
			server.listeningApp.close();
		}
	});
}

module.exports = exports['default'];
//# sourceMappingURL=assets.js.map