'use strict';

Object.defineProperty(exports, '__esModule', {
	value: true
});

var _slicedToArray = (function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i['return']) _i['return'](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError('Invalid attempt to destructure non-iterable instance'); } }; })();

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

exports.createServer = createServer;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _assets = require('./assets');

var _assets2 = _interopRequireDefault(_assets);

var _renderer = require('./renderer');

var _renderer2 = _interopRequireDefault(_renderer);

var _util = require('./util');

var _events = require('events');

var _events2 = _interopRequireDefault(_events);

var watch = {
	stats: {
		hash: false,
		cached: false,
		cachedAssets: false,
		colors: true,
		modules: false,
		chunks: false
	}
};

var Server = (function (_EventEmitter) {
	_inherits(Server, _EventEmitter);

	function Server(_ref) {
		var client = _ref.client;
		var server = _ref.server;

		_classCallCheck(this, Server);

		_get(Object.getPrototypeOf(Server.prototype), 'constructor', this).call(this);

		// Create the servers.
		this.assets = (0, _assets2['default'])(client, { watch: watch });
		this.renderer = (0, _renderer2['default'])(server, { watch: watch });
	}

	_createClass(Server, [{
		key: 'address',
		value: function address() {
			return this.renderer.address();
		}
	}, {
		key: 'listen',
		value: function listen() {
			var _this2 = this;

			var _normalizeListen = _util.normalizeListen.apply(undefined, arguments);

			var _normalizeListen2 = _slicedToArray(_normalizeListen, 3);

			var port = _normalizeListen2[0];
			var addr = _normalizeListen2[1];
			var cb = _normalizeListen2[2];

			var _this = this;

			if (typeof cb === 'function') {
				this.once('listening', cb);
			}

			// Readiness.
			var state = {
				render: false,
				stats: false,
				assets: false
			};
			var notified = false;

			function mark(entry, val) {
				state[entry] = val;
				if (!notified && Object.keys(state).every(function (key) {
					return state[key];
				})) {
					notified = true;
					_this.emit('listening');
				}
			}

			// Output some info.
			this.renderer.on('listening', function () {
				mark('render', 'http://localhost:' + _this2.renderer.address().port);
			});

			// When we know where the assets are being served, then send that info to the
			// rendering server. Same goes for when new assets have been created.
			this.assets.on('listening', function () {
				var url = 'http://localhost:' + _this2.assets.address().port;
				// TODO: Fix this properly.
				// This is a little bit hacky, but `publicPath` is used internally by
				// webpack to request hot updates and so it needs to accurately reflect
				// the location of the asset server. There is a bit of a race condition
				// here where the stats event could occur after the listen one and not
				// contain the updated path. This seems to work for now.
				_this2.assets.compiler.options.output.publicPath = url + '/';
				mark('assets', url);
				_this2.renderer.assets(url);
			}).on('stats', function (stats) {
				mark('stats', stats);
				_this2.renderer.stats(stats);
			});

			this.assets.listen(0);
			this.renderer.listen(port, addr);
		}
	}, {
		key: 'close',
		value: function close() {
			this.assets.close();
			this.renderer.close();
		}
	}]);

	return Server;
})(_events2['default']);

function createServer(options) {
	return new Server(options);
}
//# sourceMappingURL=server.js.map